DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Static Public Member Functions | Private Attributes | List of all members
FGDerivationImage Class Reference

Class representing the "Derivation Image Functional Group Macro". More...

Inheritance diagram for FGDerivationImage:

## Public Member Functions
| FGDerivationImage ()
| Constructor creating an empty functional group.
virtual | ~FGDerivationImage ()
| Virtual destructor, frees memory.
virtual FGBase * | clone () const
| Returns a deep copy of this object. More...
virtual int | compare (const FGBase &rhs) const
| Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value! Both objects (this and rhs) need to have the same type (i.e. both FGDerivationImage) to be comparable. More...
virtual DcmFGTypes::E_FGSharedType | getSharedType () const
| Returns shared type of this functional group. More...
virtual OFCondition | addDerivationImageItem (const CodeSequenceMacro &derivationCode, const OFString &derivationDescription, DerivationImageItem *&item)
| Convenience function to add an item only having a single derivation code derivation description. More...
virtual void | clearData ()
| Clears all data handled by this component.
virtual OFCondition | check () const
| Checks whether this class contains valid data. More...
virtual OFVector< DerivationImageItem * > & | getDerivationImageItems ()
| Get reference to derivation image items. More...
virtual OFCondition | read (DcmItem &item)
| Read Derivation Image Sequence from given item, which can contain zero or more items. More...
virtual OFCondition | write (DcmItem &item)
| Write Derivation Image Sequence (containing contain zero or more items) to given item. More...
Public Member Functions inherited from FGBase
| FGBase (const DcmFGTypes::E_FGType fgType)
| Constructor, creates new functional group of given type. More...
virtual DcmFGTypes::E_FGType | getType () const
| Return the type of this functional group. More...
virtual | ~FGBase ()
| Virtual destructor.

## Static Public Member Functions
static FGDerivationImage * | createMinimal (const OFVector< ImageSOPInstanceReferenceMacro > &derivationImages, const OFString &derivationDescription, const CodeSequenceMacro &derivationCode, const CodeSequenceMacro &purposeOfReference)
| Convenience function to create a minimalistic FGDerivationImage. More...

## Private Attributes
OFVector< DerivationImageItem * > | m_DerivationImageItems
| List of derivation image items making up the Derivation Image Sequence.

## Additional Inherited Members
Protected Member Functions inherited from FGBase
virtual OFCondition | getItemFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, const unsigned long itemNum, DcmItem *&result)
| Get the item containing the payload of a functional group sequence, identified by the functional group's sequence key provided and the desired item number. More...
virtual OFCondition | getNumItemsFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, unsigned long &result)
| Get number of items in a functional group sequence, identified by the functional group's sequence key. More...
virtual OFCondition | createNewFGSequence (DcmItem &destination, const DcmTagKey &seqKey, const unsigned long numItems, DcmItem *&firstItem)
| Create functional group sequence specified by given sequence tag key. More...

## Detailed Description

Class representing the "Derivation Image Functional Group Macro".

## Member Function Documentation

## ◆ addDerivationImageItem()

virtual OFCondition FGDerivationImage::addDerivationImageItem | ( | const CodeSequenceMacro & | derivationCode,
|  | const OFString & | derivationDescription,
|  | DerivationImageItem *& | item
| ) |  |
| virtual

Convenience function to add an item only having a single derivation code derivation description.

No source images have to provided but can be added later on the resulting DerivationImageItem.

Parameters

  derivationCode | Code describing derivation
  derivationDescription | Free text description of derivation (can be empty)
  item | The created derivation image item if successful, NULL otherwise

Returns
  EC_Normal if adding works, error code otherwise

## ◆ check()

virtual OFCondition FGDerivationImage::check | ( |  | ) | const
| virtual

Checks whether this class contains valid data.

Returns
  EC_Normal if data is valid, error otherwise

Implements FGBase.

## ◆ clone()

virtual FGBase* FGDerivationImage::clone | ( |  | ) | const
| virtual

Returns a deep copy of this object.

Returns
  Deep copy of this object

Implements FGBase.

## ◆ compare()

virtual int FGDerivationImage::compare | ( | const FGBase & | rhs | ) | const
| virtual

Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value! Both objects (this and rhs) need to have the same type (i.e. both FGDerivationImage) to be comparable.

This function is used in order to decide whether a functional group already exists, or is new. This is used in particular to find out whether a given functional group can be shared (i.e. the same information already exists as shared functional group) or is different from the same shared group. In that case the shared functional group must be distributed into per-frame functional groups, instead. The exact implementation for implementing the comparison is not relevant. However, it must be a comparison by value.

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if either the value of the first component that does not match is lower in the rhs object, or all compared components match but the rhs component is shorter. Also returned if this type and rhs type (DcmFGTypes::E_FGType) do not match. 1 if either the value of the first component that does not match is greater in the rhs object, or all compared components match but the rhs component is longer.

Implements FGBase.

## ◆ createMinimal()

static FGDerivationImage* FGDerivationImage::createMinimal | ( | const OFVector< ImageSOPInstanceReferenceMacro > & | derivationImages,
|  | const OFString & | derivationDescription,
|  | const CodeSequenceMacro & | derivationCode,
|  | const CodeSequenceMacro & | purposeOfReference
| ) |  |
| static

Convenience function to create a minimalistic FGDerivationImage.

Parameters

  derivationImages | The list of SOP instances to reference
  derivationDescription | Description of the derivation performed
  derivationCode | Coded representation of the derivation description
  purposeOfReference | Purpose of referencing the SOP instances

Returns
  The created derivation image item, if successful, NULL otherwise

## ◆ getDerivationImageItems()

virtual OFVector<DerivationImageItem*>& FGDerivationImage::getDerivationImageItems | ( |  | ) |
| virtual

Get reference to derivation image items.

Returns
  Reference to derivation image items

## ◆ getSharedType()

virtual DcmFGTypes::E_FGSharedType FGDerivationImage::getSharedType | ( |  | ) | const
| inline virtual

Returns shared type of this functional group.

Returns
  Always returns DcmFGTypes::EFGS_BOTH

Implements FGBase.

References DcmFGTypes::EFGS_BOTH.

## ◆ read()

virtual OFCondition FGDerivationImage::read | ( | DcmItem & | item | ) |
| virtual

Read Derivation Image Sequence from given item, which can contain zero or more items.

Parameters

  item | The item to read from

Returns
  Returns EC_Normal if at least one derivation image item could be read or no item exists at all, otherwise an error is returned

Implements FGBase.

## ◆ write()

virtual OFCondition FGDerivationImage::write | ( | DcmItem & | item | ) |
| virtual

Write Derivation Image Sequence (containing contain zero or more items) to given item.

Parameters

  item | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise

Implements FGBase.

The documentation for this class was generated from the following file:

- dcmfg/include/dcmtk/dcmfg/fgderimg.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1